c      Emulation of John Barker's UNIX/Linux runtest_all
c      for Windows. To be compiled with g77.
c      V1.0 23-Oct-2003

       program runtest_all

       character*255 working_directory,
      2              answer*1,
      3              command
c
c      All failed calls to intrinics report the error and
c      stop the program.
c
       call getCWD(working_directory,istatus)
       if(istatus.ne.0)then
           write(6,fmt='(''getCWD failed, status='',i4)')istatus
           stop
       endif

       write(6,fmt='('' '')')
       write(6,fmt='(''Running all tests'')')

       answer='A'
       do while(answer.ne.'Y'.and.answer.ne.'N')
10         write
      2    (6,fmt='(''Does your PATH include '',a,'' [y/n]? '',$)')
      3    working_directory(1:lenstr(working_directory))
           read(5,fmt='(a)',err=10)answer
           call upper(answer)
           if(answer.ne.'Y'.and.answer.ne.'N')then
               write(6,fmt='(''Answer y or n.'')')
           endif
       enddo
       if(answer.eq.'N')then
           write(6,fmt='(''Modify your PATH to include '',a)')
      2        working_directory(1:lenstr(working_directory))
           stop
       elseif(answer.eq.'Y')then
c
c          Calling system to perform CD's directly fails; we
c          write, execute, and delete a batch file instead.
c
           open(unit=1,file='runtest_all.bat',status='unknown')

           command='cd '//
      2    working_directory(3:lenstr(working_directory))//
      3    '\\src\\multiwell\\test'
           write(1,fmt='(a)')command(1:lenstr(command))

           command='.\\runtest.exe'       
           write(1,fmt='(a)')command(1:lenstr(command))

           command='cd '//
      2    working_directory(3:lenstr(working_directory))//
      3    '\\src\\densum\\test'
           write(1,fmt='(a)')command(1:lenstr(command))

           command='.\\runtest.exe'       
           write(1,fmt='(a)')command(1:lenstr(command))

           command='cd '//
      2    working_directory(3:lenstr(working_directory))//
      3    '\\src\\mominert\\test'
           write(1,fmt='(a)')command(1:lenstr(command))

           command='.\\runtest.exe'       
           write(1,fmt='(a)')command(1:lenstr(command))

           command='cd '//
      2    working_directory(3:lenstr(working_directory))//
      3    '\\src\\thermo\\test'
           write(1,fmt='(a)')command(1:lenstr(command))

           command='.\\runtest.exe'       
           write(1,fmt='(a)')command(1:lenstr(command))

           write(1,fmt='(''echo ''''Tests Finished'''' '')')

           close(unit=1,status='keep')

           command=working_directory(3:lenstr(working_directory))//
     3     '\\runtest_all.bat'
           call system(command,istatus)
           if(istatus.ne.0)then
               write(6,fmt=
     2  '(''runtest_all:runtest_all.bat: system failed, status='',i4)')
     3         istatus
               stop
           endif
c
c          Delete the batch file, we're done.
c
           command='del '//
     2     working_directory(3:lenstr(working_directory))//
     3     '\\runtest_all.bat'
           call system(command,istatus)
           if(istatus.ne.0)then
               write(6,fmt=
     2  '(''runtest_all:runtest_all.bat: system failed, status='',i4)')
     3         istatus
               stop
           endif


       endif
      
       stop
       end
c
      function lenstr(string)
c
      implicit      none
c
      character*(*) string,  !input string
     2              null*1   !null character
c
      integer*4     i,       !string index
     2              iend,    !candidate for string length
     3              j,       !index used for stepping through string
     4              length,  !defined length of input
     5              lenstr   !length of string
c
      length=len(string)
c
c     Look for the existence of nulls; if there
c     are any, the first one marks one character past the
c     end of the defined string. If there are no nulls,
c     pick up the final nonspace character, and call that
c     the defined length of the string.
c
      null=char(0)
c
c     Look for nulls
c
      iend=index(string(1:length),null)
c
c     No nulls, look for the location of the last nonspace.
c
      if(iend.eq.0)then
          do i=1,length
              j=length+1-i
              if(string(j:j).ne.' ')then
                  lenstr=j
                  return
              endif
          enddo
c
c         all spaces
c
          lenstr=0
          return
      else
c
c         first null-1
c
          lenstr=iend-1
          return
      endif
      end
c
c     Converts any lowercase characters in an arbitrary string to uppercase.
c
      subroutine upper(string)
      character*(*) string,lowers*26,uppers*26
c
      lowers='abcdefghijklmnopqrstuvwxyz'
      uppers='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
c
c     Convert to upper case, if necessary.
c
      do i=1,len(string)
          n=index(lowers,string(i:i))
          if(n.ne.0)string(i:i)=uppers(n:n)
      enddo
      return
      end
